import os, sys
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from qgis.core import *
from qgis.gui import *

class ReportWindow(QDialog):
    def __init__(self,parent=None):
        super(ReportWindow,self).__init__()
        self.myCheckboxes = {}
        self.myLayouts = []
        introLayout = QHBoxLayout()
        introLabel = QLabel("Inserire le seguenti informazioni prima di predisporre la stampa del Report")
        introLayout.addWidget(introLabel)

        comuneLayout = QVBoxLayout()
        comuneLabel = QLabel("Comune")
        self.comuneCombo = QComboBox()
        self.comuneCombo.addItems(self.getComuniList())
        comuneLayout.addWidget(comuneLabel)
        comuneLayout.addWidget(self.comuneCombo)

        profLayout = QVBoxLayout()
        profLabel = QLabel("Nome Professionista")
        self.profLine = QLineEdit()
        profLayout.addWidget(profLabel)
        profLayout.addWidget(self.profLine)

        infoLayout= QHBoxLayout()
        infoLayout.addLayout(comuneLayout)
        infoLayout.addLayout(profLayout)

        checkLayout = QVBoxLayout()

        self.createCheckbox(1,'Carta delle indagini',checkLayout)
        self.createCheckbox(2,'Carta geologico-tecnica per la microzonazione sismica (CGT) in scala 1:5.000',checkLayout)
        self.createCheckbox(3,'Sezioni geologico-tecniche in scala 1:5.000',checkLayout)
        self.createCheckbox(4,'Carta delle frequenze naturali dei terreni in scala 1:5.000',checkLayout)
        self.createCheckbox(5,'Carta delle microzone omogenee in prospettiva sismica (MOPS) in scala 1:5.000',checkLayout)
        self.createCheckbox(6,'N. 3 Carte di microzonazione sismica di livello 3 in scala 1:5.000 per gli intervalli di periodo (T): 0.1-0.5 s, 0.4-0.8 s, 0.7-1.1 s',checkLayout)
        self.createCheckbox(7,'Relazione illustrativa',checkLayout)
        self.createCheckbox(8,'Scheda excel dei metadati',checkLayout)
        formatGroupbox = QGroupBox("Sono stati predisposti i seguenti prodotti?")
        formatGroupbox.setLayout(checkLayout)

        buttonLayout = QHBoxLayout()
        self.okButton = QPushButton("Salva")
        self.cancelButton = QPushButton("Chiudi")
        buttonLayout.addWidget(self.okButton)
        buttonLayout.addWidget(self.cancelButton)
        QObject.connect(self.okButton, SIGNAL("clicked()"), self, SLOT("accept()"))
        QObject.connect(self.cancelButton, SIGNAL("clicked()"), self, SLOT("reject()"))

        generalLayout = QVBoxLayout()
        generalLayout.addLayout(introLayout)
        generalLayout.addLayout(infoLayout)
        generalLayout.addWidget(formatGroupbox)
        generalLayout.addLayout(buttonLayout)
        self.setLayout(generalLayout)
        self.setWindowTitle("Predisposizione Report")

    def createCheckbox(self,i,text,checkLayout):
        self.myCheckboxes[i] = QCheckBox(text)
        checkLayout.addWidget(self.myCheckboxes[i])

    def getComuniList(self):
        LISTACOMUNI = []
        shpPath = os.path.join(os.path.dirname(os.path.dirname(os.path.dirname(__file__))),'BasiDati','Comuni','Comuni.shp')
        print shpPath
        layer = QgsVectorLayer(shpPath,'layer','ogr')
        for feature in layer.getFeatures():
            LISTACOMUNI.append(feature.attribute('nome'))
        LISTACOMUNI.sort()
        LISTACOMUNI.insert(0,'')
        return LISTACOMUNI

    def accept(self):
        if self.profLine.text() in ['', ' ', None]:
            QMessageBox.critical(None,"Errore","Devi inserire il nome del Professionista")
            return
        if self.comuneCombo.currentText() in ['', ' ', None]:
            QMessageBox.critical(None,"Errore","Devi inserire il nome del Comune")
            return
        QDialog.accept(self)

if __name__ == '__main__':
    win = ReportWindow()
    win.exec_()




